package com.pjwstk.mp03;

import java.util.EnumSet;
import java.util.HashSet;
import java.util.Set;

import com.pjwstk.entities.Client;
import com.pjwstk.entities.Employee;
import com.pjwstk.entities.Phone;
import com.pjwstk.entities.clients.Musician;
import com.pjwstk.entities.utils.ExtensionHandle;
import com.pjwstk.mp02.AssociationHandle;

public class PersonD extends AssociationHandle{

	private Integer id_person;
	private String name;
	private String surname;
	//atrybut powtarzalny
	private Set<Phone> phones;
	
	//TODO Temporary id generator [change with JPA annotations+Hibernate]
	private static Integer id = 0;
	
	private static final String parrent = "generalization";
	private static final String client = "expandToClient";
	private static final String employee = "expandToEmployee";
	
	private static final String genderMA = "gender";
	private static final String multiaspect = "multiaspect"; 

	public String getName() {
		return name;
	}

	public void setName(String name) {
		this.name = name;
	}

	public String getSurname() {
		return surname;
	}

	public void setSurname(String surname) {
		this.surname = surname;
	}

	public Set<Phone> getPhones() {
		return phones;
	}

	public void setPhones(Set<Phone> phones) {
		this.phones = phones;
	}
	
	protected PersonD(PersonD clone){
		this(clone.getName(),clone.getSurname(),clone.getPhones(),clone.getGender());
	}

	protected PersonD(String name, String surname,Set<Phone> phones,Gender gender) {
		super();
		this.id_person = id++;
		this.name = name;
		this.surname = surname;
		this.phones = phones;
		this.addAssociation(genderMA, multiaspect, gender);
	}
	
	protected PersonD(String name, String surname,Phone phone,Gender gender) {
		super();
		this.id_person = id++;
		this.name = name;
		this.surname = surname;
		this.phones = new HashSet<Phone>();
		this.phones.add(phone);
		this.addAssociation(genderMA, multiaspect, gender);
	}
	
	public Gender getGender(){
		return !this.getAssociation(genderMA).isEmpty()?
				(Gender)this.getAssociation(genderMA).get(0):null;
	}
	
	@Override
	public String toString() {
		return "["+super.toString()+"]name:"+this.name+", surname:"
				+this.surname+", gender:"+this.getAssociation(genderMA)+", phones:"+this.phones;
	}
	
}
